<template>
  <span>
    <gl-button id="scim-filter-help" variant="link" icon="question-o" aria-label="Help" />
    <gl-popover target="scim-filter-help">
      Example filters:

      <ul class="gl-pl-5">
        <li v-for="(example, description) in $options.exampleQueries" :key="example">
          <gl-button variant="link" class="gl-text-wrap-wrap" @click="$emit('query', example)">{{
            description
          }}</gl-button>
        </li>
      </ul>

      Useful properties of findings to filter on:

      <ul class="gl-pl-5">
        <li v-for="property in $options.usefulFindingProperties" :key="property">
          <code>{{ property }}</code>
        </li>
      </ul>
    </gl-popover>
  </span>
</template>

<script>
import GlButton from '@gitlab/ui/src/components/base/button/button.vue';
import GlPopover from '@gitlab/ui/src/components/base/popover/popover.vue';

export default {
  name: 'ScimFilterHelp',
  components: {
    GlButton,
    GlPopover,
  },
  exampleQueries: {
    Violations: 'extra.severity eq "ERROR"',
    'Compliant tests': 'extra.severity eq "INFO"',
    'Violations in {ee,~}/issues': 'extra.severity eq "ERROR" and path co "/issues/"',
  },
  usefulFindingProperties: [
    'check_id',
    'extra.lines',
    'extra.message',
    'extra.severity',
    'path',
    'extra.group',
  ],
};
</script>
